<?php

/*******************************************************************************
Copyright (c) 2013 Clear Admin Software Kft.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met: 

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/


//tested with eshop 4.3.2


$vat_percent = 27;

//Csatlakozas adatbazishoz
require_once(dirname(__FILE__).'/../wp-config.php');


if(!mysql_connect(DB_HOST, DB_USER, DB_PASSWORD))
{
	show_error("DB open: " . mysql_error());
}
if(!mysql_select_db(DB_NAME))
{
	show_error("DB select: " . mysql_error());
}

//if(!mysql_query('SET NAMES utf-8'))
if(!mysql_query('SET CHARACTER SET '.DB_CHARSET))
{
	show_error("Unable to set character set. ".mysql_error());
}


$last_orderhead_timestamp = $_GET['last_orderhead_timestamp'];
$max_orders = $_GET['max_orders'] + 0;
if(!$max_orders)
	$max_orders = 30;



	
$table_name = $table_prefix . "eshop_orders";
$q = "select * from $table_name where edited  >= ".
	($last_orderhead_timestamp+0) ." order by edited limit $max_orders";

$res = mysql_query($q);
if(!$res)
	show_error("select order: [$q] " . mysql_error());

	
//print '<'.'?xml version="1.0" encoding="UTF-8" standalone="yes" ?'.'>' . "\n";

print "<!DOCTYPE ORDERS>\n";
print "<ORDERS>\n";

while($order_ary = mysql_fetch_assoc($res))
{
	show_order($order_ary);
}

?>
</ORDERS>
<?php



function show_order($order)
{

	global $table_prefix;
	$table_name = $table_prefix . "eshop_order_items";
	$q = "select * from $table_name where checkid = '$order[checkid]'";
	$items = db_get_records($q);

	$today_str = date('Y-m-d');
	$shipped_date_str = $today_str; //TODO: adatbazisbol

	//TODO: PARTNER_CODE név és cím alapján

	?>

		<ORDER>
			<ORDERHEAD_CODE><?php echo $order['id']?></ORDERHEAD_CODE>
			<ORDERHEAD_TIMESTAMP><?php echo $order['edited']?></ORDERHEAD_TIMESTAMP>

			<ORDERHEAD_PARTNER_NAME><?php echo he(strlen($order['company']) ? $order['company'] : $order['last_name'].' '.$order['first_name'])?></ORDERHEAD_PARTNER_NAME>
			<ORDERHEAD_PARTNER_ZIP><?php echo he($order['zip'])?></ORDERHEAD_PARTNER_ZIP>
			<ORDERHEAD_PARTNER_CITY><?php echo he($order['city'])?></ORDERHEAD_PARTNER_CITY>
			<ORDERHEAD_PARTNER_ADDRESS><?php echo he($order['address1'].' '.$order['address2'])?></ORDERHEAD_PARTNER_ADDRESS>

			<ORDERHEAD_PAYMENTMETHOD_CODE><?php echo $order['paidvia']?></ORDERHEAD_PAYMENTMETHOD_CODE>
			<ORDERHEAD_PAYMENTMETHOD_NAME><?php echo $order['paidvia']?></ORDERHEAD_PAYMENTMETHOD_NAME>

			<ORDERHEAD_DATE_SHIPPED><?php echo $shipped_date_str?></ORDERHEAD_DATE_SHIPPED>
			<ORDERHEAD_DATE_PAYMENT_DUE><?php echo $today_str?></ORDERHEAD_DATE_PAYMENT_DUE>

			<ORDERHEAD_SUBJECT>Internetes vásárlás - megrendelés azonosítója: <?php echo $order['id']+0?></ORDERHEAD_SUBJECT>

			<ORDERHEAD_VERIFIED>1</ORDERHEAD_VERIFIED>
			<?php
				
				show_orderitems($items);
				
			?>

		</ORDER>
	<?php
}

function show_orderitems($items)
{
	global $table_prefix;
	global $vat_percent;
	if(!$items)
		return;
	foreach($items as $item)
	{
		//termek betoltese
		$table_name = $table_prefix . "posts";
		$q = "select * from $table_name where ID = $item[post_id]";
		$post = db_get_record($q);


		
		$comment_str = '';

		//statisztikai szamjel (VTSZ/SZJ)
		$statno = '';
		if($item['post_id']==0){
			$name = 'Szállítási költség';
		}else{
			$name = he($post['post_content']);
		}
		$comment_str = $item['item_id'];
		$unit = 'db';
		$vat_code = $vat_percent;
		$price = $item['item_amt'] * 100 / (100+$vat_percent);
		
		?>

			<ORDERITEM>
				<ORDERITEM_CODE><?php echo $item['id']?></ORDERITEM_CODE>

				<ORDERITEM_PRODUCT_CODE><?php echo $item['post_id']?></ORDERITEM_PRODUCT_CODE>
				<ORDERITEM_STAT_NO><?php echo  $statno ?></ORDERITEM_STAT_NO>
				<ORDERITEM_NAME><?php echo $name?></ORDERITEM_NAME>
				<ORDERITEM_COMMENT><?php echo $comment_str?></ORDERITEM_COMMENT>
				<ORDERITEM_UNIT><?php echo $unit?></ORDERITEM_UNIT>
				<ORDERITEM_VAT_CODE><?php echo $vat_code?></ORDERITEM_VAT_CODE>
				<ORDERITEM_VAT_PERCENT><?php echo $vat_percent?></ORDERITEM_VAT_PERCENT>
				<ORDERITEM_VAT_NAME><?php echo ($vat_percent+0).'%'?></ORDERITEM_VAT_NAME>

				<ORDERITEM_PRICE><?php echo $price?></ORDERITEM_PRICE>
				<ORDERITEM_QTY><?php echo $item['item_qty']?></ORDERITEM_QTY>
			</ORDERITEM>
		<?php
	}
}


function he($s)
{
	//return htmlentities($s);
	return $s;
}

function show_error($error_str)
{
	echo($error_str);
	die();
}

function db_get_record($q)
{
	$res = mysql_query($q);
	if(!$res)
		show_error("db_get_record(): [$q] " . mysql_error());
	return mysql_fetch_assoc($res);
}

function db_get_field($q)
{
	$res = mysql_query($q);
	if(!$res)
		show_error("db_get_field(): [$q] " . mysql_error());
	$row = mysql_fetch_row($res);
	if($row == FALSE) return FALSE;
	return $row[0];
}

function db_get_records($q)
{
	$res = mysql_query($q);
	if(!$res)
		show_error("db_get_records [$q] " . mysql_error());
	$ret_ary = array();
	while($ary = mysql_fetch_assoc($res))
	{
		$ret_ary[] = $ary;
	}
	if(count($ret_ary))
		return $ret_ary;
	return FALSE;
}

function db_get_map($q)
{
	$res = mysql_query($q);
	if(!$res)
		show_error("db_get_map [$q] " . mysql_error());
	$ret_ary = array();
	while($ary = mysql_fetch_row($res))
	{
		$ret_ary[$ary[0]] = $ary[1];
	}
	if(count($ret_ary))
		return $ret_ary;
	return FALSE;
}

function ary_to_utf8($ary)
{
	$res = array();
	foreach($ary as $k => $v)
	{
		if(!is_array($v))
		{
			$res[$k] = mb_convert_encoding($v, 'UTF-8', 'ISO-8859-2');
		}
		else
		{
			$res[$k] = $v;
		}
	}
	return $res;
}

?>
